#pragma once
#include "sprite.h"
#include "text.h"

#ifndef MENU_H
#define MENU_H

//Clase menu
class Menu
{
public:
	//Constructor
	Menu();

	//Destructor
	~Menu();

	//Inicializador
	void init(int x, int y, int backgroundType, LTexture *texture, SDL_Renderer *renderer, Text *text);

	//Obtiene el valor de la variable
	Uint8 getItemSelected();

	//Mueve el grafico del selector al elemento seleccionado
	void moveSelectorSprite(int pos);

	//Deja el menu apuntando al primer elemento
	void resetMenu();

	//Deja el menu apuntando al siguiente elemento
	void increaseSelectorIndex();

	//Deja el menu apuntando al elemento anterior
	void decreaseSelectorIndex();

	//Comprueba la entrada (teclado, gamepad) y actua en consecuencia
	void checkInput(Uint8 input);

	//Pinta el menu en pantalla
	void render();

	//Establece el rectangulo de fondo del menu
	void setRectSize();

	//Establece el valor de la variable
	void setTotalItems(int num);

	//Establece el color del rectangulo de fondo
	void setBackgroundColor(int r, int g, int b, int alpha);

	//Centra el menu respecto a un punto
	void centerMenu(int value);

	//Centra los elementos del menu respecto a un punto
	void centerMenuElements(int value);

	//Añade un item al menu
	void addItem(std::string text);

private:
	//Posicion X/Y del texto del primer elemento del menu
	int mPosX;
	int mPosY;

	//Elemento del menu que tiene el foco
	Uint8 mSelectorIndex;

	//Numero de items del menu
	Uint8 mTotalItems;

	//Item del menu que ha sido seleccionado
	Uint8 mItemSelected;

	//Tipo de fondo para el menu
	Uint8 mBackgroundType;

	//Sprite con los graficos del selector
	Sprite mSelectorSprite;

	//Rectangulo y colores para el fondo del menu
	SDL_Rect mRect;
	Uint8 mRectR; //Rojo
	Uint8 mRectG; //Verde
	Uint8 mRectB; //Azul
	Uint8 mRectA; //Alfa o transparencia

	//Estructura para cada elemento del menu
	struct MenuItem
	{
		std::string label;
		int x;
		int y;
	};
	MenuItem mMenuItem[10];

	//Texto para poder escribir los items del menu
	Text *mText;

	//Puntero al renderizador de la ventana
	SDL_Renderer *mRenderer;
};

#endif
